import org.junit.Rule;
import org.junit.Test;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.lang.reflect.Method;

import org.junit.contrib.java.lang.system.StandardOutputStreamLog;
import org.junit.rules.Timeout;

import static org.junit.Assert.assertEquals;

public class Aufgabe4Test {

    @Rule
    public Timeout globalTimeout = new Timeout(100);

    @Test
    public void test() throws Exception {
            Method check = Aufgabe4.class.getDeclaredMethod("check", String.class);
            assertEquals(true, check.getReturnType().equals(boolean.class));
            check.setAccessible(true);
            assertEquals(true, check.invoke(null, ""));
            assertEquals(true, check.invoke(null, "a*[a+12]"));
            assertEquals(true, check.invoke(null, "a+(b)-c"));
            assertEquals(true, check.invoke(null, "a+{b+8+(b+c)}/a"));
            assertEquals(false, check.invoke(null, "["));
            assertEquals(false, check.invoke(null, ")"));
            assertEquals(false, check.invoke(null, "[}"));
            assertEquals(false, check.invoke(null, "()}"));
            assertEquals(false, check.invoke(null, "([)]"));
            assertEquals(false, check.invoke(null, "]["));
    }

}
