import org.junit.Rule;
import org.junit.Test;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

import org.junit.contrib.java.lang.system.StandardOutputStreamLog;
import org.junit.rules.Timeout;

import static org.junit.Assert.assertEquals;

public class Aufgabe1Test {

    @Rule
    public Timeout globalTimeout = new Timeout(100);

    @Test
    public void test() throws Exception {
        Method set = Aufgabe1.class.getDeclaredMethod("set", int.class, int.class);
        Method get = Aufgabe1.class.getDeclaredMethod("get");
        assertEquals(true, get.getReturnType().equals(String.class));
        Method inc = Aufgabe1.class.getDeclaredMethod("inc");
        Constructor<Aufgabe1> constr = Aufgabe1.class.getConstructor(int.class, int.class);
        Aufgabe1 nz1 = constr.newInstance(0, 0);
        Aufgabe1 nz2 = constr.newInstance(3, 99);
        assertEquals("0.0.0", get.invoke(nz1));
        assertEquals("3.99.0", get.invoke(nz2));
        for (int i = 0; i < 99; i++) {
            inc.invoke(nz1);
            inc.invoke(nz2);
        }
        assertEquals("0.0.99", get.invoke(nz1));
        assertEquals("3.99.99", get.invoke(nz2));
        inc.invoke(nz1);
        inc.invoke(nz2);
        assertEquals("0.1.0", get.invoke(nz1));
        assertEquals("4.0.0", get.invoke(nz2));
        inc.invoke(nz1);
        inc.invoke(nz2);
        assertEquals("0.1.1", get.invoke(nz1));
        assertEquals("4.0.1", get.invoke(nz2));
        set.invoke(nz1, 7, 99);
        assertEquals("7.99.0", get.invoke(nz1));
        for (int i = 0; i < 100; i++) {
            inc.invoke(nz1);
        }
        assertEquals("0.0.0", get.invoke(nz1));
    }

}